<?php
/*
   GalleryAdv.php
   
   (c) Bernhard Weichel
   
   $Log: GalleryAdv.php,v $
   Revision 1.6  2004/02/19 14:42:45  beweiche
   merged with getthumbnaiil.php

   Revision 1.5  2003/11/02 14:48:12  beweiche
   snapshot

   Revision 1.4  2003/09/13 12:16:32  beweiche
   thumb page now generates an upload to the orginal image

   Revision 1.3  2003/09/09 21:22:04  beweiche
   removed debug prints
   fixed bug in thumbnail size calculation

   Revision 1.2  2003/09/09 20:52:42  beweiche
   added thumbnail creation

   Revision 1.1  2003/09/07 19:07:09  beweiche
   *** empty log message ***

   
   
*/



  $DefaultWebMenu = "Main/WebMenu";


// This pattern refers to an image in the Thumbnail page
// should give back three parameters
//   image name, thumbnail size, image title
//   image name is used as a basis for computing resized images
//   thumbnail size is the size of the thumbs printed here
//   image title is printed along with the thumb and also presented
//      in imagetrail

  $ImagePattern = '/^\.image[ ]+([^\t ]+)[ ]+([^\t ]+)(.*)$/e';
  $ImagePatternInlinex = '/\\[\\[\\$image[ ]+([^\t ]+)[ ]+([^\t \\]]+)\\]\\]*/e';
  $ImagePatternInline = '/[[$image[ ]+([^ ]+)[ ]+([^ ]+)]]/e';
  
  $DoubleBrackets[$ImagePattern] ="FmtImageThumb('$1', '$2', '$3')";
//  $DoubleBrackets[$ImagePatternInline] ="FmtImageThumb('$1', '$2', '$3')";
  
//todo: make a good inline markup  
  
//  $InlineReplacements[$ImagePatternInline] ="FmtImageThumbInline('$1', '$2')";
  
  
function FmtImageThumbInline($name, $size)
 {
  return "Attach:".$name."x".$size.".jpg";
 }
  
// end of todo
  
function FmtImageThumb($name, $size, $title)
 {
  global $pagename;

  // make sure that the name of the uploaded file is mangled in the
  // same way as wikipages. This makes the image page having the same name as the filename

  $thename= FmtWikiLink('',"{{".$name."}}", NULL,'PageName',$pagename);  // pagename of the current image
  $thename= FmtPageName('$Title', $thename);                                // Extract the title to be used as filename
  
  print "<div class='thumbnail'>";

  PrintText($pagename, "[==][[{{".$thename."}} Attach:".FmtImageFileName($thename, $size)."]]"
                        ." [[{{".$thename."}} ".$title."]]" );
  print "</DIV>";
  return "";
 }
                                 
// the Default text for an image page                          
                          
  $DefaultPageTextFmt = "no remarks ";  

// redefine link formats

   // todo: restrict it on a gallery page

$WikiPageCreateFmt = "<a href='\$PageUrl'>\$LinkText</a>" ;
$WikiPageCreateSpaceFmt = "<a href='\$PageUrl'>\$LinkText</a>" ;

// Making an image filename

function FmtImageFileName($name, $size)
 {
    global $UploadFileFmt,$pagename;
    
    $originalfilename=$name.".jpg";
    $originalfilepath=FmtPageName($UploadFileFmt,$pagename).$originalfilename;
    
    if (file_exists($originalfilepath))
     {
      if ($size == "original") {$filename=$originalfilename;}                                  
      else {
        $filename=$name."x".$size.".jpg";
        $filepath=FmtPageName($UploadFileFmt,$pagename).$filename;
        GetThumbnail($originalfilepath, $filepath,  $size);
        }
      }
    else
      {
       $filename=$originalfilename;
      }
    
    return $filename;

 }

// now the gallery trails
  
$DoubleBrackets["/^\.imagetrail ($FreeLinkPattern)/e"] 
  = 'MakeImageTrailStop("$1");';
$DoubleBrackets["/^\.imagetrail/e"] 
  = 'MakeImageTrailStop("$ImageTrail");';

function MakeImageTrailStop($link) {
  global $pagename;
  $t = ReadImageTrail($link);
  $prev = ''; $next = '';
  for($i=0;$i<count($t);$i++) {
    if ($t[$i]['name']==$pagename) {
      $ImageTitle=$t[$i]['title'];
      if ($i>0) $prev = "[[".$t[$i-1]['link']." &larr;]]";
      if ($i+1<count($t)) $next =  "[[".$t[$i+1]['link']." &rarr;]]";
    }
  }
  return "<center>$prev  $link  $next </center><center><H1>$ImageTitle</H1></center>";
}


function ReadImageTrail($link) {
  global $pagename, $ImagePattern;
  $trailname = FmtWikiLink('',$link,NULL,'PageName');
  $trailpage = ReadPage($trailname);
  if ($trailpage) {
    $trailgroup = FmtPageName('$Group',$trailname);
    $n = 0;
    foreach(explode("\n",$trailpage['text']) as $x) {
      if (preg_match("$ImagePattern", $x,$match)) {
        $t[$n]['img' ] = $match[1];                                                   // name of the current image
        $t[$n]['link' ] = $trailgroup."/{{".$match[1].'}}';                           // Wikilink of the current imabe
        $t[$n]['size' ] = $match[2];                                                  // requested size of the image
        $t[$n]['title'] = $match[3];                                                  // title of the current image
        $t[$n]['name'] = FmtWikiLink('',$t[$n]['link'], NULL,'PageName',$trailpage);  // pagename of the current image

        $n++;
      } 
    }
  }
  return $t;
}


/*   
   
Format

   status=GetThumbnail(<sourcefile>, <targetfile>,  size)
   
Arguments
   
 sourcefile: the name of the sourcefile which shall be rescaled 
             to size and saved as targetfile
 
 targetfile: the name of the result file. If the targefile exists
             scaling is done only if the sourcefile is newer. 
             but in this case targetfile is overwritten .

 size      : Size is a square of pixels in which the target image
             should fit. Scaling should only be performed downwards.
             Scaling algorith "bicubical".
            
Behavior

 creates an up to date downscaled image from sourcefile.
 
 * scaling is done only if the sourcefile is bigger than the
   size
   
 * size creates a square into which the target image shall fit
 
 * scaling is done "bicubial" algorithm
 
 * scaling is done only if targetfile does not exist or is
   out of date.
   
 * if sourcefile is smaller than size, then it is copied to 
   targetfile
   
   
*/



  function GetThumbnail( $source, $target, $size ) {
    // variables declaration
    $sourceF = array();
    $targetF = array();;

    // check if there is a need to create a new thumbnail
    if(!file_exists($target) || filemtime($source) > filemtime($target)) {
      // get the image-information
      list($sourceF['width'], $sourceF['height'], $sourceF['type'], $sourceF['html']) = GetImageSize($source);
      // check if source image is smaller than the resulting thumbnail
      if($sourceF['height'] > $size || $sourceF['width'] > $size) {
        $sourceF['image'] = LoadImage( $source, $sourceF['type'] );
        $targetF['image'] = CreateThumbnail( $sourceF, $size );

    // write out the newly created thumbnail
    if(isset($sourceF['image'])) {
      SaveImage( $targetF['image'], $sourceF['type'], $target );
    }
      } else {
    // copy the targetfile to the source-file
    copy( $source, $target );
      }
    }
  }

  function CreateThumbnail( $source, $size ) {
    // calculate a new size
    //***print_r($source);
    $f = min($size / $source['height'], $size / $source['width'] );
    $ny = $f * $source['height'];
    $nx = $f * $source['width'];

    // create the thumbnail
    //***print_r($nx);print_r($ny);print_r($size);
    $im  = ImageCreateTrueColor($nx, $ny);
    ImageCopyResampled($im, $source['image'], 0, 0, 0, 0, $nx, $ny, $source['width'], $source['height']);
    return $im;
  
  }

  function LoadImage ($imgname, $imgtype) {
    switch($imgtype) {
      case 1:
        if(!function_exists('ImageCreateFromGIF')) {
      trigger_error("GIF input functions not avialable", E_USER_ERROR);
    } else {
          $im = @ImageCreateFromGIF( $imgname );
    }
    break;

      case 2:
        if(!function_exists('ImageCreateFromJPEG')) {
          trigger_error("JPEG input functions not avialable", E_USER_ERROR);
        } else {
          $im = @ImageCreateFromJPEG( $imgname );
        }
    break;

      case 3:
        if(!function_exists('ImageCreateFromPNG')) {
          trigger_error("PNG input functions not avialable", E_USER_ERROR);
        } else {
          $im = @ImageCreateFromPNG( $imgname );
        }
    break;
    }
    
    if(!isset($im))
      trigger_error("Could not create GD-Image-Stream.", E_USER_ERROR);
    return $im;
  }

  function SaveImage( $im, $imgtype, $filename ) {
    // check if the type is supported
    switch ($imgtype) {
      case '1':
        if (!function_exists('ImageGIF')) {
          trigger_error('GIF output functions not available', E_USER_ERROR);
        } else {
          @ImageGIF($im, $filename);
        }
        break;
      case '2':
        if (!function_exists('ImageJPEG')) {
          trigger_error('JPEG output functions not available', E_USER_ERROR);
        } else {
          @ImageJPEG($im, $filename);
        }
        break;
      case '3':
        if (!function_exists('ImagePNG')) {
          trigger_error('PNG output functions not available', E_USER_ERROR);
        } else {
          @ImagePNG($im, $filename);
        }
        break;
    }
    ImageDestroy($im);
  }

?>